const state = {
    purchaseOrders: [],
    filteredPurchaseOrders: [],
    loadingPurchaseOrders: false,
    selectedPurchaseOrder: null
}

const getters = {
    loadingPurchaseOrders(state) {
        return state.loadingPurchaseOrders
    },
    purchaseOrders(state) {
        return state.purchaseOrders
    },
    visiblePurchaseOrders(state) {
        return state.filteredPurchaseOrders.length === 0 ? state.purchaseOrders : state.filteredPurchaseOrders
    },
    selectedPurchaseOrder(state) {
        return state.purchaseOrders
    }
}

const mutations = {
    setLoadingPurchaseOrder(state, loading) {
        state.loadingPurchaseOrders = !!loading
    },
    setPurchaseOrders(state, purchaseOrders) {
        state.purchaseOrders = purchaseOrders
    },
    setFilteredPurchaseOrders(state, filteredPurchaseOrders) {
        state.filteredPurchaseOrders = filteredPurchaseOrders
    },
    setSelectedPurchaseOrder(state, purchaseOrder) {
        state.selectedPurchaseOrder = purchaseOrder
    }
}

const actions = {
    initPurchaseOrders({ commit }, purchaseOrders) {
        commit('setPurchaseOrders', purchaseOrders)
        commit('setLoadingPurchaseOrder')
    },
    filterPurchaseOrders({ commit }, filtered) {
        commit('setFilteredPurchaseOrders', filtered)
    },
    selectPurchaseOrder({ commit, dispatch }, saleOrder) {
        commit('setSelectedPurchaseOrder', saleOrder)
    }
}

export default {
    state,
    getters,
    actions,
    mutations
}